// standard boilerplate start for .h file -- avoids duplication if the file
// is #include'd more than once.
#ifndef PRA_BASE_H
#define PRA_BASE_H

#include <string>
#include <vector>
using std::string;
using std::vector;

class PRA {
    public:
        // destructor
        // apparently this is needed for abstract classes?
        virtual ~PRA(void) {}

        // methods concrete subclasses must define

        // provide name of algorithm
        virtual string getName(void) const = 0;

        // simulate operation of algorithm 
        virtual Results simulate(
                const long numFrames,
                const long numPages,
                const long interval,
                const long tau,
                const vector<PageReference> &refs) = 0;
};

#endif

