// standard boilerplate start for .h file -- avoids duplication if the file
// is #include'd more than once.
// FIXME change this if you copy this file.
#ifndef PTE_H
#define PTE_H

#include <cstdlib>

// HINT:
// you may want to make a subclass of this if you're implementing an algorithm 
// that is best done by assuming a somewhat more capable MMU.  (LRU is the 
// example that comes to mind.)
// you probably do *not* want to extend this class for algorithms such as
// Aging, where a separate table of counters seems to me better.
class PTE {
    public:
        
        // variables 

        bool valid;
        unsigned long frame;

        bool rBit;
        bool mBit;

        // constructor

        PTE(void) : valid(false), rBit(false), mBit(false) {}

        // methods

        static void printPageTable(const vector<PTE> &pageTable);
};

void PTE::printPageTable(const vector<PTE> &pageTable) {
    printf("page table (valid pages):\n");
    const char *fmtString = "  %4s %10s %5s %5s\n";
    printf(fmtString, "page", "frame", "rBit", "mBit");
    for (size_t i = 0; i < pageTable.size(); ++i) {
        if (pageTable[i].valid) {
            printf(fmtString,
                    std::to_string(i).c_str(),
                    std::to_string(pageTable[i].frame).c_str(),
                    (pageTable[i].rBit ?  "r" : ""),
                    (pageTable[i].mBit ?  "m" : ""));
        }
    }
}
#endif
