// standard boilerplate start for .h file -- avoids duplication if the file
// is #include'd more than once.
// FIXME change this if you copy this file.
#ifndef RESULTS_H
#define RESULTS_H

#include <cstdio>

class Results {
    public:

        // variables

        long refs = 0;
        long writeRefs = 0;
        long pageFaults = 0;
        long pageWriteOuts = 0;

        bool isValid = false;

        // constructor

        Results(void) :
            refs(0), writeRefs(0), pageFaults(0), pageWriteOuts(0),
            isValid(false) {}
 
        // methods

        void clear(void);

        void print(void) const;
};

void Results::clear(void) {
    refs = 0;
    writeRefs = 0;
    pageFaults = 0;
    pageWriteOuts = 0;
}

void Results::print(void) const {
    printf("Total number of references %ld\n", refs);
    printf("Total number of write references %ld\n", writeRefs);
    printf("Number of page faults %ld\n", pageFaults);
    printf("Number of times a page was written out %ld\n", 
            pageWriteOuts);
}
#endif
